<?php
/*
Plugin Name: SEO Pagebar 
Plugin URI: http://www.fob-marketing.de/marketing-blog-545-seo-pagebar.html  
Description: Adds an advanced SEO navigation to Wordpress. 
Version: 1.1 
Author: Oliver Bockelmann (fob marketing) 
Author URI: http://www.fob-marketing.de/ 
Update Server: http://wordpress.org/extend/plugins/seo-pagebar/ 
Min WP Version: 
Max WP Version: 2.3 
*/

/*  
	This plugin is just a modified (SEO) version of the famous Pagebar Plugin 
    supported by "Elektroelch". 
	
	History: 
	
	SEO Pagebar 1.0: 10-16-2007: more links, more scale, more link juice... ;-) 
	SEO Pagebar 1.1: 10-19-2007: added support for WordPress Pages (CMS compatibility).  
	
	SEO Pagebar is provided as is. It will not 
	be supported by fob and should be used on your own risk. The plugin should 
	be fully compatible to Pagebar version 1.3.3 which could be found here: 
	http://elektroelch.de/hacks/wp/pagebar/  
*/ 

/*  
	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   
*/

/*  
	Original Script by: Lester Chan ( http://www.lesterchan.net/portfolio/programming.php ) 
	Pagebar Plugin by Lutz Schr&ouml;er ( http://www.elektroelch.de/hacks/wp/pagebar.html ) 
	SEO Pagebar by Oliver Bockelmann ( http://www.fob-marketing.de/marketing-blog-545-seo-pagebar.html )
*/ 

/* --------------------------------------------------------------------------------------------- */ 
function pbShowTooltip($tooltip, $tooltipText, $page) { 
  if ($tooltip) { 
    return ' title="' . $tooltipText . ' ' . $page .'"'; 
	} 
} 

/* --------------------------------------------------------------------------------------------- */ 
function new_get_pagenum_link($i=1) { 
  return attribute_escape(get_pagenum_link($i)); 
} 
/* --------------------------------------------------------------------------------------------- */ 

function wp_pagebar($params) { 
  global $request, $posts_per_page, $wpdb, $paged, $wp_pagebar, $wp_version, $wp_query;
	
/* Handle default values */ 
  if (! isset($params['before'])) { 
  
  	if ( is_category() ) { 
		$params['before'] = ''; 
	
	} else { 
		$params['before'] = ''; 
	} 
  
  } 

  if (! isset($params['after']))         { $params['after']        = ''; } 
  if (! isset($params['tooltip']))       { $params['tooltip']      = true; } 
  if (! isset($params['tooltip_text']))  { $params['tooltip_text'] = 'Page'; } 
  if (! isset($params['prev']))          { $params['prev']         = '&#9668;'; } 
  if (! isset($params['next']))          { $params['next']         = '&#9658;'; } 
  if (! isset($params['directions']))    { $params['directions']   = true; } 
		
  if (!is_single()) { 

  /* Needed to reload SEO Pagebar for Categories. Don`t know why - but works (fob) */ 
	if ( ($wp_version < "2.1") || (is_category()) ) { 
		  preg_match('#FROM\s(.*)\sGROUP BY#siU', $request, $matches); 

		} else { 
		  preg_match('#FROM\s(.*)\sORDER BY#siU', $request, $matches); 
		} 

	$fromwhere = $matches[1]; 

    if (substr_count($fromwhere,"stptags")>0) { 
      $fromwhere=str_replace(" GROUP BY wp_posts.ID HAVING COUNT(ID) = 1","",$fromwhere); 
    } 
	
   /* Change Request on Page Templates */ 
   if(substr_count($fromwhere,"post_type = 'page'")>0) { 
    $fromwhere="wp_posts WHERE 1=1 AND post_type = 'post' AND (post_status = 'publish' OR post_status = 'private')"; 
   } 
    
	$numposts = $wpdb->get_var("SELECT COUNT(DISTINCT ID) FROM $fromwhere"); 
	$max_page = ceil($numposts /$posts_per_page); 
	
	/* Tagging-Support since WordPress 2.3 */ 
    if (function_exists('is_tag')) { 
      if (is_tag()) { 
        $max_page = $wp_query->max_num_pages; 
		} 
	} 

	/*  " if (!isset($paged)) " didn`t work for me - so we changed this. (fob)  */ 
 	if ($paged == 0) { 
   		$paged = 1; 
  	} 
	
	/* Seconnd last page */ 
	$max_page_2 = ($max_page - 1); 

		
/* *************************************************************************************** */ 
/* Start SEO Pagebar... */ 

	if($max_page > 1) { 
			
			echo '<div class="pagebar">' . $params['before']; 
			
			if ($paged > 1 && $params['directions']) { 
				echo '<a href="'.trim(new_get_pagenum_link($paged-1)).'" '.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $paged-1).'>'.$params['prev'].'</a> '; 
			} 


/* Navigation on first pages */ 

			if ($paged < 8) { 
				
				for($i = $paged - 7 ; $i <= $paged + 7; $i++) { 
					if ($i >= 1 && $i <= 8 && $i <= $max_page) { 
						if($i == $paged) { 
							echo '<span class="this-page">'.$i.'</span>'; 
						} else { 
							echo ' <a href="'.new_get_pagenum_link($i).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $i) .'>'.$i.'</a> '; 
						} 
					}
				} 
				

			if ($max_page > 8) { 
				echo ' <span class="break">...</span> 
					<a href="'.new_get_pagenum_link($max_page-1).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $max_page).'>'.$max_page_2.'</a> 
					<a href="'.new_get_pagenum_link($max_page).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $max_page).'>'.$max_page.'</a>'; 
				} 


/* Navigation on last pages */ 

			} else if ( $paged >= ($max_page - 7) ) { 
			
				echo '
				<a href="'.new_get_pagenum_link($paged-$paged+1).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], "1").'>1</a> 
				<a href="'.new_get_pagenum_link($paged-$paged+2).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], "2").'>2</a> 
				<span class="break">...</span> '; 
			
				for($i = $paged - 8; $i <= $paged + 8; $i++) { 
					if ($i >= $max_page - 8 && $i <= $max_page) { 
						if($i == $paged) { 
							echo '<span class="this-page">'.$i.'</span>'; 
						} else { 
							echo ' <a href="'.new_get_pagenum_link($i).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $i) .'>'.$i.'</a> '; 
						} 
					}
				} 
	

/* Other pages */ 

			} else { 
				
				echo '
					<a href="'.new_get_pagenum_link($paged-$paged+1).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], "1").'>1</a> 
					<a href="'.new_get_pagenum_link($paged-$paged+2).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], "2").'>2</a> 
					<span class="break">...</span> '; 
				
				for($i = $paged - 3 ; $i <= $paged + 3; $i++) { 
					if ( $i >= 1 && $i <= $max_page ) { 
						if($i == $paged) { 
							echo '<span class="this-page">'.$i.'</span>'; 
						} else { 
							echo ' <a href="'.new_get_pagenum_link($i).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $i) .'>'.$i.'</a> ';
						}
					} 
				} 
	
				if ( ($paged + 2) < ($max_page) ) { 
					echo ' <span class="break">...</span> 
					<a href="'.new_get_pagenum_link($max_page-1).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $max_page).'>'.$max_page_2.'</a> 
					<a href="'.new_get_pagenum_link($max_page).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $max_page).'>'.$max_page.'</a>'; 
				} 

			} 
			

/* Next pages */ 

		  if ($paged < $max_page && $params['directions']) { 
			echo ' <a href="'.new_get_pagenum_link($paged+1).'"'.pbShowTooltip($params['tooltip'],$params['tooltip_text'], $paged+1).'>'.$params['next'].'</a>'; 
		  } 
		    
	  echo $params['after'] . '</div>'; 

	}
  }
}

?>